stack-1.3.2: The Haskell Tool Stack

Safe Haskell | None
Language | Haskell2010

Stack.Constants

Description

Constants used throughout the project.

Synopsis

- buildPlanDir :: Path Abs Dir -> Path Abs Dir
- distDirFromDir :: (MonadThrow m, MonadReader env m, HasEnvConfig env) => Path Abs Dir -> m (Path Abs Dir)
- workDirFromDir :: (MonadThrow m, MonadReader env m, HasEnvConfig env) => Path Abs Dir -> m (Path Abs Dir)
- distRelativeDir :: (MonadThrow m, MonadReader env m, HasEnvConfig env) => m (Path Rel Dir)
- haskellModuleExts :: [Text]
- imageStagingDir :: (MonadReader env m, HasConfig env, MonadThrow m) => Path Abs Dir -> Int -> m (Path Abs Dir)
- projectDockerSandboxDir :: (MonadReader env m, HasConfig env) => Path Abs Dir -> m (Path Abs Dir)
- stackDotYaml :: Path Rel File
- stackRootEnvVar :: String
- stackRootOptionName :: String
- deprecatedStackRootOptionName :: String
- inContainerEnvVar :: String
- inNixShellEnvVar :: String
- configCacheFile :: (MonadThrow m, MonadReader env m, HasEnvConfig env) => Path Abs Dir -> m (Path Abs File)
- configCabalMod :: (MonadThrow m, MonadReader env m, HasEnvConfig env) => Path Abs Dir -> m (Path Abs File)
- buildCacheFile :: (MonadThrow m, MonadReader env m, HasEnvConfig env) => Path Abs Dir -> m (Path Abs File)
- testSuccessFile :: (MonadThrow m, MonadReader env m, HasEnvConfig env) => Path Abs Dir -> m (Path Abs File)
- testBuiltFile :: (MonadThrow m, MonadReader env m, HasEnvConfig env) => Path Abs Dir -> m (Path Abs File)
- stackProgName :: String
- stackProgNameUpper :: String
- wiredInPackages :: HashSet PackageName
- ghcjsBootPackages :: HashSet PackageName
- cabalPackageName :: PackageName
- implicitGlobalProjectDirDeprecated :: Path Abs Dir -> Path Abs Dir
- implicitGlobalProjectDir :: Path Abs Dir -> Path Abs Dir
- hpcRelativeDir :: (MonadThrow m, MonadReader env m, HasEnvConfig env) => m (Path Rel Dir)
- hpcDirFromDir :: (MonadThrow m, MonadReader env m, HasEnvConfig env) => Path Abs Dir -> m (Path Abs Dir)
- objectInterfaceDir :: (MonadReader env m, HasConfig env) => BuildConfig -> m (Path Abs Dir)
- templatesDir :: Config -> Path Abs Dir
- defaultUserConfigPathDeprecated :: Path Abs Dir -> Path Abs File
- defaultUserConfigPath :: Path Abs Dir -> Path Abs File
- defaultGlobalConfigPathDeprecated :: Maybe (Path Abs File)
- defaultGlobalConfigPath :: Maybe (Path Abs File)
- platformVariantEnvVar :: String
- compilerOptionsCabalFlag :: WhichCompiler -> String

# Documentation

buildPlanDir #

Arguments

:: Path Abs Dir | Stack root
-> Path Abs Dir |

Path where build plans are stored.

distDirFromDir :: (MonadThrow m, MonadReader env m, HasEnvConfig env) => Path Abs Dir -> m (Path Abs Dir) #

Package's build artifacts directory.

workDirFromDir :: (MonadThrow m, MonadReader env m, HasEnvConfig env) => Path Abs Dir -> m (Path Abs Dir) #

Package's working directory.

distRelativeDir :: (MonadThrow m, MonadReader env m, HasEnvConfig env) => m (Path Rel Dir) #

Relative location of build artifacts.

haskellModuleExts :: [Text] #

Extensions for anything that can be a Haskell module.

imageStagingDir #

Arguments

:: (MonadReader env m, HasConfig env, MonadThrow m) |
=> Path Abs Dir | Project root
-> Int | Index of image
-> m (Path Abs Dir) | Docker sandbox

Image staging dir from project root.

projectDockerSandboxDir #

Arguments

:: (MonadReader env m, HasConfig env) |
=> Path Abs Dir | Project root
-> m (Path Abs Dir) | Docker sandbox

Docker sandbox from project root.

stackDotYaml :: Path Rel File #

The filename used for the stack config file.

stackRootEnvVar :: String #

Environment variable used to override the '~/.stack' location.

stackRootOptionName :: String #

Option name for the global stack root.

deprecatedStackRootOptionName :: String #

Deprecated option name for the global stack root.

Deprecated since stack-1.1.0.

TODO: Remove occurences of this variable and use `stackRootOptionName` only after an appropriate deprecation period.

inContainerEnvVar :: String #

Environment variable used to indicate stack is running in container.

inNixShellEnvVar :: String #

Environment variable used to indicate stack is running in container. although we already have STACK_IN_NIX_EXTRA_ARGS that is set in the same conditions, it can happen that STACK_IN_NIX_EXTRA_ARGS is set to empty.

configCacheFile #

Arguments

:: (MonadThrow m, MonadReader env m, HasEnvConfig env) |
=> Path Abs Dir | Package directory.
-> m (Path Abs File) |

The filename used for dirtiness check of config.

configCabalMod #

Arguments

:: (MonadThrow m, MonadReader env m, HasEnvConfig env) |
=> Path Abs Dir | Package directory.
-> m (Path Abs File) |

The filename used for modification check of .cabal

buildCacheFile #

Arguments

:: (MonadThrow m, MonadReader env m, HasEnvConfig env) |
=> Path Abs Dir | Package directory.
-> m (Path Abs File) |

The filename used for dirtiness check of source files.

testSuccessFile #

Arguments

:: (MonadThrow m, MonadReader env m, HasEnvConfig env) |
=> Path Abs Dir | Package directory
-> m (Path Abs File) |

The filename used to mark tests as having succeeded

testBuiltFile #

Arguments

:: (MonadThrow m, MonadReader env m, HasEnvConfig env) |
=> Path Abs Dir | Package directory
-> m (Path Abs File) |

The filename used to mark tests as having built

stackProgName :: String #

Name of the `stack` program.

stackProgNameUpper :: String #

Name of the `stack` program, uppercased

wiredInPackages :: HashSet PackageName #

ghcjsBootPackages :: HashSet PackageName #

cabalPackageName :: PackageName #

Just to avoid repetition and magic strings.

implicitGlobalProjectDirDeprecated #

Arguments

:: Path Abs Dir | Stack root.
-> Path Abs Dir |

Deprecated implicit global project directory used when outside of a project.

implicitGlobalProjectDir #

Arguments

:: Path Abs Dir | Stack root.
-> Path Abs Dir |

Implicit global project directory used when outside of a project. Normally, `getImplicitGlobalProjectDir` should be used instead.

hpcRelativeDir :: (MonadThrow m, MonadReader env m, HasEnvConfig env) => m (Path Rel Dir) #

Relative location of directory for HPC work.

hpcDirFromDir #

Arguments

:: (MonadThrow m, MonadReader env m, HasEnvConfig env) |
=> Path Abs Dir | Package directory.
-> m (Path Abs Dir) |

Directory for HPC work.

objectInterfaceDir :: (MonadReader env m, HasConfig env) => BuildConfig -> m (Path Abs Dir) #

Output .o/.hi directory.

templatesDir :: Config -> Path Abs Dir #

Directory for project templates.

defaultUserConfigPathDeprecated :: Path Abs Dir -> Path Abs File #

Deprecated default global config path.

defaultUserConfigPath :: Path Abs Dir -> Path Abs File #

Default global config path. Normally, `getDefaultUserConfigPath` should be used instead.

defaultGlobalConfigPathDeprecated :: Maybe (Path Abs File) #

Deprecated default global config path. Note that this will be `Nothing` on Windows, which is by design.

defaultGlobalConfigPath :: Maybe (Path Abs File) #

Default global config path. Normally, `getDefaultGlobalConfigPath` should be used instead. Note that this will be `Nothing` on Windows, which is by design.

platformVariantEnvVar :: String #

Environment variable that stores a variant to append to platform-specific directory names. Used to ensure incompatible binaries aren't shared between Docker builds and host

compilerOptionsCabalFlag :: WhichCompiler -> String #

Provides --ghc-options for `Ghc`, and similarly, --ghcjs-options for `Ghcjs`.